All Activity
- Yesterday
-
EXTRACT TEXT OF SIDE (SEGEMENTS) FROM POLYGON
leo321 replied to leo321's topic in AutoLISP, Visual LISP & DCL
hi, @GLAVCVS very interesting, I'll try something along these lines, thx for the tip, This thinking is very reverse engineering style, nice -
jorge ortega joined the community
-
EXTRACT TEXT OF SIDE (SEGEMENTS) FROM POLYGON
GLAVCVS replied to leo321's topic in AutoLISP, Visual LISP & DCL
Hi @leo321 I suppose we can assume that the green text labels will always be within a proximity range less than their height from the vertex of the red polygon they refer to (2 drawing units). Based on this premise and considering that your drawings will be of very limited dimensions, the algorithm could be somewhat simpler: - Create a selection set for red polylines - For each red polyline/polygon: 1) Obtain its list of points and run an ssget "_WP" just for the red text. Presumably, there will only be one text per set. If it's not the only one, you can apply a 'raycast' (Lee Mac) or an 'r4+' to check which of the two is the centroid. 2) Run an ssget "_C" with a window the size of the height of the green text, with each point in the polygon. If, in any case, more than one green text is selected, check which of the two is closest to the vertex. In either case, associate the selected green text with the polygon's centroid label using a list. - Express the contents of the resulting association list through whatever means the user deems appropriate. -
EXTRACT TEXT OF SIDE (SEGEMENTS) FROM POLYGON
Lee Mac replied to leo321's topic in AutoLISP, Visual LISP & DCL
In that case, simply exclude steps 1 & 4 from the algorithm. -
EXTRACT TEXT OF SIDE (SEGEMENTS) FROM POLYGON
leo321 replied to leo321's topic in AutoLISP, Visual LISP & DCL
to minimize, you don't even need to count the vertexes, if you only have a list of the sequence of the sides following the original sequence in the polygon it would be enough. this data will already be ready and nothing will be created (I refer to the texts), when the green numbering I left it just as an illustration but it doesn't even need to exist, because the reference will always be the vertexes of the polygon. -
Lee Mac started following EXTRACT TEXT OF SIDE (SEGEMENTS) FROM POLYGON
-
EXTRACT TEXT OF SIDE (SEGEMENTS) FROM POLYGON
Lee Mac replied to leo321's topic in AutoLISP, Visual LISP & DCL
A possible algorithm might be: Obtain set of vertex text (green text). Obtain set of region label text (red text). Obtain green polyline. Iterate over the set of polyline vertices and associate the green text content with each vertex by matching the text position with the vertex coordinates (so that the vertices can be labelled independently of their sequence in the polyline definition). For each red text object, call the BOUNDARY command to create a temporary boundary polyline using the text insertion point/alignment point as the internal point. Attempt to match the vertices of the boundary polyline with those of the green polyline and acquire the vertex numbers for all matches. Create a range from the matching vertex numbers. Delete the temporary boundary polyline. Continue until all red text objects have been processed. Sort the results by minimum vertex number in the vertex number range. -
Thank you for reply Lee. I will try tomorrow. I'm sure it will work .
-
Steven P started following Prevent a pdf from being converted to dwg
-
Prevent a pdf from being converted to dwg
Steven P replied to maahee's topic in AutoCAD Drawing Management & Output
Not a lot you can do, if the project time and budget allows we can always create a DWG from any supplied data, PDFs included. You could make it a hassle to convert, use anything apart from true type fonts might get converted as lines. Explode dashed lines, centre etc to individual parts. Explode all blocks, polylines, texts, mtexts, delete hatch boundaries, offset all lines a very small amount in any direction, flatten the drawing to layer 0, set a few random entities at a Z value other than where they should be, convert arcs, circles, polyline bulges to straight line equivalents, Insert specific drawing styles, names and so on that identify you as the drawing owner (sheep as a full stop are my favourite). You could convert such a PDF back to CAD but make it very tricky to work with. A these steps can be automated if necessary, remember don't save the drawing once it is messed up. How far you want to annoy anyone wanting to convert the PDF is up to you, all you are doing is slowing down the conversion, maybe to an extent that it isn't worth it. It can always be converted back though.... even if it is redrawn 99% -
7yuio joined the community
-
leo321 started following EXTRACT TEXT OF SIDE (SEGEMENTS) FROM POLYGON
-
Guys, as I show in the attached image, If there is already a lisp that extracts the text from the polygon segment and generates a table or exports it to csv, on each side that contains text (each text will be inside a closed polygon). use the sequence of the original vertex of the polygon as a reference. I tried to find something similar but I couldn't find it. Thanks for your help. Sampple side.dwg
-
If [Layer prefix] exists, do stuff
supertruper1988 replied to supertruper1988's topic in AutoLISP, Visual LISP & DCL
Many thanks Lee! -
Selection pop up??
SLW210 replied to Mory's topic in AutoCAD 2D Drafting, Object Properties & Interface
SELECTIONCYCLING = 0 will turn it off AutoCAD 2019 Help | SELECTIONCYCLING (System Variable) | Autodesk There is a button on the bottom toolbar (I have mine gone) and CTRL + W toggles it ON and OFF -
Lee Mac started following Convert a .lsp file into a .scr file and If [Layer prefix] exists, do stuff
-
If [Layer prefix] exists, do stuff
Lee Mac replied to supertruper1988's topic in AutoLISP, Visual LISP & DCL
FWIW, the code can be condensed to: (defun c:checkhpf ( / def fnd ) (while (and (not fnd) (setq def (tblnext "layer" (not def)))) (setq fnd (wcmatch (strcase (cdr (assoc 2 def))) "HPF*")) ) (if fnd (princ "\nLayer found.") (princ "\nLayer not found.") ) (princ) ) -
Convert a .lsp file into a .scr file
Lee Mac replied to NicuT's topic in AutoLISP, Visual LISP & DCL
There's no need to convert it, you can load & call it from a Script file, e.g. the script could be as simple as: (load "YourLISPFile.lsp" nil) (if c:doit (c:doit)) -
Does anybody know why this dialogue box started popping up on me every time I pick an object that may be a block I"ve inserted into my dwg?
-
If [Layer prefix] exists, do stuff
supertruper1988 replied to supertruper1988's topic in AutoLISP, Visual LISP & DCL
After doing some reading, I remembered that ChatGPT exists and could help me. It did and this is the code it gave: (defun c:CheckHPFLayers () (setq found nil) ; Assume no layers are found initially (setq layerTable (tblnext "LAYER" T)) ; Get first layer (while layerTable (if (wcmatch (cdr (assoc 2 layerTable)) "HPF*") ; Check if layer name starts with "HPF" (setq found T) ; Set found to true if a match is found ) (setq layerTable (tblnext "LAYER")) ; Get next layer ) (if found (princ "TRUE\n") ; Print "TRUE" if a layer was found (princ "FALSE\n") ; Print "FALSE" if no layer was found ) (princ) ; Suppress extra return values ) I hope this can help anyone further with a similar issue -
supertruper1988 started following If [Layer prefix] exists, do stuff
-
Hello, Long time reader and implementer but I have just signed up because I have hit a wall. What I need to do is check to see if any layer that starts with HPF exists and then do some stuff after. Here is what I have tried (if (= (tblsearch "LAYER" "HPF*") nil) (princ "\nTrue.") (princ "\nFalse.") ) I have simplified it down to just testing because I know I can get it to work if I ask for a specific layer name but I need it to be a wildcard if possible. I think instead of a simple test like is this not nil I rather need to test if the list of layers has HPF but my google fu is failing me to find out what that function is called in autolisp. Thanks in advance.
-
hsyedshuja started following AutoLISP, Visual LISP & DCL
-
supertruper1988 joined the community
-
itacad started following Toolbars and Snap Windows (WIN11)
-
Toolbars and Snap Windows (WIN11)
itacad posted a topic in The CUI, Hatches, Linetypes, Scripts & Macros
Hi, I'm trying to write this request on this section of the forum because it seems the most relevant to me. I confess that when it comes to using Autocad I am very "conservative" and I have never converted to the Ribbon view, continuing to prefer the classic view and the toolbars that I have customized over time to recall the lisps that I use daily. I really appreciate the WIN11 feature that allows you to tile windows, which I sometimes use to place other windows side by side in AutoCAD. However, when I switch the AutoCAD view from full window to half window, unfortunately I lose access to the toolbars located on the right side. The question I ask is this: is it possible to reduce the AutoCAD window, and still keep all the toolbars visible (which should redistribute automatically then). I thank you in advance for any suggestions, I realize that it is a bit of a strange request.... -
hsyedshuja started following BIGAL
-
Hello. Things are quiet almost everywhere, but not in a good way. Uncertainty is bad for business, y'know. Nobody is sure what's going to happen next.
-
hsyedshuja joined the community
-
At one job they had a software package called Bluebeam. It can measure objects for you. Not free, but if your client is willing to pay for Adobe, they can pay for this.
-
dexus started following Modifying Block Linear Parameter Properties (not values)
-
Modifying Block Linear Parameter Properties (not values)
dexus replied to seawind's topic in AutoLISP, Visual LISP & DCL
Have a look at dynamic block functions from Lee: https://lee-mac.com/dynamicblockfunctions.html Namely LM:setdynpropvalue for changing a value of a dynamic property. -
gegeti6483 joined the community
-
Trying to layout Church seating using divide and insert block
SLW210 replied to Cadmando-'s topic in AutoLISP, Visual LISP & DCL
Are they on a flat floor or is it a sloped floor? Are the circles in the image columns? If so, those seats need removed. You also have to consider how good is the view, seats may need to be staggered. Do you know the needed aisle width and the available legal occupancy capacity of the room? There are some YouTube Videos for Blender etc. and Blender Forums, some sights should show the math behind it. A drawing might help. -
Modifying Block Linear Parameter Properties (not values)
SLW210 replied to seawind's topic in AutoLISP, Visual LISP & DCL
Please use Code Tags! (<> in the editor toolbar) -
In the future please use Code Tags for your code. (<> in the editor toolbar) I have created a new thread for your inquiry. Convert a .lsp file into a .scr file
-
Design Presentation joined the community
-
Modifying Block Linear Parameter Properties (not values)
seawind posted a topic in AutoLISP, Visual LISP & DCL
Is there a way to modify a dxf code of a BlockLinearParameter modified Lee's function LM:getvisibilityparametername to : (defun LM:getDnmcprmtrlst ( blk par / lst) ;"BLOCKLINEARPARAMETER" "BLOCKVISIBILITYPARAMETER""ACAD_EVALUATION_GRAPH" (if (and (vlax-property-available-p (setq blk (if (= 'ENAME (type blk)) (vlax-ename->vla-object blk) blk)) 'effectivename) (setq blk (vla-item(vla-get-blocks (vla-get-document blk))(vla-get-effectivename blk))) (= :vlax-true (vla-get-isdynamicblock blk)) (= :vlax-true (vla-get-hasextensiondictionary blk)) ) (setq lst (vl-remove-if ''((x)(eq x nil)) (mapcar ''((pair)(if (and (= 360 (car pair)) (= par (cdr(assoc 0 (entget(cdr pair))))) ) (cdr pair) ) ) (dictsearch(vlax-vla-object->ename(vla-getextensiondictionary blk))"ACAD_ENHANCEDBLOCK") ) ) ) (princ (strcat "\nThis Block doesnt contain " par)) ) (if lst lst) (princ) ) (LM:getDnmcprmtrlst (car(entsel)) "BLOCKLINEARPARAMETER") (setq lst (entget(car lst)) !lst ((-1 . <Entity name: 30f5358c0b0>) (0 . "BLOCKLINEARPARAMETER") (5 . "661D63") (102 . "{ACAD_XDICTIONARY") (360 . <Entity name: 30f5358c750>) (102 . "}") (330 . <Entity name: 30f5358c0a0>) (100 . "AcDbEvalExpr") (90 . 48) (98 . 33) (99 . 329) (100 . "AcDbBlockElement") (300 . "Linear") (98 . 33) (99 . 329) (1071 . 32) (100 . "AcDbBlockParameter") (280 . 1) (281 . 0) (100 . "AcDbBlock2PtParameter") (1010 0.0 0.0 0.0) (1011 0.240209 0.549818 0.0) (170 . 4) (91 . 52) (91 . 49) (91 . 0) (91 . 0) (171 . 1) (92 . 52) (301 . "DisplacementX") (172 . 1) (93 . 52) (302 . "DisplacementY") (173 . 1) (94 . 49) (303 . "DisplacementX") (174 . 1) (95 . 49) (304 . "DisplacementY") (177 . 0) (100 . "AcDbBlockLinearParameter") (305 . "Distance1") (306 . "") (140 . 0.076861) (307 . "") (96 . (141 . 0.6) (142 . 1.0) (143 . 0.1) (175 . 0))) i have reached to this list and i want to (entmod (subst (cons 96 7) (assoc 96 lst) lst)) but i get the error message : ; error: bad DXF group: (1071 . 32) playing with linear parameters noticed that dxf 1071 is changing value from 0 to 33 (if that can help) My knowledge roofed and i need some assistance dxf 96 controls the dist type and 7 is used for increment 3 for none and 8 for list furthermore dxf 141 stores the dist increment, 142 the dist minimum and 143 dist maximum. So when i insert a block i want to assign linear parameters with different values on all the above without the need of doing it after manually one by one The general questions are : Is there any command or a way to change those values other than the properties window ? The above list is a DICTIONARY so we cant entmod the entrries ? If so, how we can modify those values, via coding ? -
NicuT joined the community
-
Hello everyone. Can you help me to convert a .lsp file into a .scr file? Below, you will find the .lsp file (quick selection - multiple objects and set to a specific layer). I want to use the .scr file with ScriptPro for multiple .dwg files. (defun C:DOIT () (command "_.chprop" (ssget "_X" '((0 . "Mtext,Multileader") )) "" "_layer" "G-ANNO-TXNT" "") )
-
Zemir6840 joined the community
-
Prevent a pdf from being converted to dwg
nod684 replied to maahee's topic in AutoCAD Drawing Management & Output
plot your file to Image using PublishToWeb plotter. Convert the Image to PDF